#include <stdio.h>
#include <string.h>

#define MAXSTR 4096

typedef struct _imginfo {
	char name[MAXSTR];
	int width, height, alt;
} IMGINFO;

struct _param {
	unsigned upper:1;
	unsigned alt:1;
} param;



int outf(int outstav, IMGINFO *imginfo, int out, char *s) {
	switch (out) {
		case 0: break;
		case 1: strupr(s); if (!strcmp(s, "IMG")) return 1; break;
		case 2: strupr(s); if (outstav == 1) {
			if (!strcmp(s, "SRC")) return 2;
			else if (!strcmp(s, "WIDTH")) imginfo->width = 1;
			else if (!strcmp(s, "HEIGHT")) imginfo->height = 1;
			else if (!strcmp(s, "ALT")) imginfo->alt = 1;
			return 1;
		} break;
		case 3: if (outstav == 2) strcpy(imginfo->name, s); if (outstav) return 1; break;
	}
	return 0;
}

int imgsize(FILE *outfile, char *path, IMGINFO *imginfo) {
	FILE *img;
	int i, width, height;
	unsigned length;
	char imgname[MAXSTR], *s;

	#pragma warn -pia
	strcpy(imgname, path);
	strcat(imgname, imginfo->name);
	for (s=imgname; s=strchr(s, '/'); *s='\\') ;
	if (imginfo->width && imginfo->height && (!param.alt || imginfo->alt)) return 0; //neteba zpracovat
	if (!(img=fopen(imgname, "rb"))) return -1; //nepodailo se zpracovat
	if (getc(img) == 'G' && getc(img) == 'I' && getc(img) == 'F') { //GIF
		fseek(img, 6, SEEK_SET);
		width = getc(img); width += 256*getc(img); if (width<0) return -1;
		height = getc(img); height += 256*getc(img); if (height<0) return -1;
	}
	else {
		fseek(img, 0, SEEK_SET);
		if (getc(img) == 255 && getc(img) == 0xD8) { //JPEG
			while (1) {
				for ( ; getc(img) != 255; ) ;
				for ( ; (i = getc(img)) == 255; ) ;
				if (i == 0xDA || i == 0xD9) {
					imginfo->width=1; imginfo->height=1;
					break;
				}
				else if (i >= 0xC0 && i <= 0xCF) {
					fseek(img, 3, SEEK_CUR);
					height = 256*getc(img); height += getc(img); if (height<0) return -1;
					width = 256*getc(img); width += getc(img); if (width<0) return -1;
					break;
				}
				else {
					length = 256*getc(img); length += getc(img);
					if (length < 2) {
						imginfo->width=1; imginfo->height=1;
						break;
					}
					else fseek(img, length - 2, SEEK_CUR);
				}
			}
		}
		else { imginfo->width=1; imginfo->height=1; }
	}
	if (!imginfo->width) fprintf(outfile, " %s=\"%d\"", param.upper ? "WIDTH" : "width", width);
	if (!imginfo->height) fprintf(outfile, " %s=\"%d\"", param.upper ? "HEIGHT" : "height", height);
	if (param.alt && !imginfo->alt) {
		fseek(img, 0, SEEK_END);
		fprintf(outfile, " %s=\"%s (%ld bytes)\"", param.upper ? "ALT" : "alt", imginfo->name, ftell(img));
	}
	fclose(img);
	return 1; //podailo se zpracovat
}

void imginfo_reset(IMGINFO *imginfo) {
	*imginfo->name = 0;
	imginfo->width = 0;
	imginfo->height = 0;
	imginfo->alt = 0;
}

int main(int argc, char *argv[]) {
	FILE *infile, *outfile;
	int i, j, stav, width, height, jinak, lambda, outcount=0, outstav=0;
	int imgerrs=0, imgoks=0, imgskips=0;
	char out[MAXSTR], s_infile[MAXSTR], s_outfile[MAXSTR], path[MAXSTR], *s;
	IMGINFO imginfo;
	int stavy[][9] = {
		{ 0, 0,'<', 1,-1},
		{ 2,-1,' ', 1,'>',0,'!',9,-1},
		{ 2, 1,' ', 3,'>',0,-1},
		{ 4,-1,' ', 3,'>',0,-1},
		{ 4, 2,' ', 5,'>',0,'=',6,-1},
		{ 4,-1,' ', 5,-1},
		{ 8,-1,' ', 6,'"',7,-1},
		{ 7, 3,'"', 3,-1},
		{ 8, 3,' ', 3,'>',0,-1},
		{ 9,-1,'-',10,'>',0,-1},
		{ 9,-1,'-',11,-1},
		{11,-1,'-',12,-1},
		{11,-1,'-',13,-1},
		{13,-1,'-',14,'>',0,-1},
		{13,-1,'-',11,'>',0,-1},
	};

	param.alt = param.upper = 0;
	imginfo_reset(&imginfo);
	for (*s_infile=0, *s_outfile=0, i=1; i < argc; i++) {
		if (*argv[i] == '/') switch (strupr(argv[i]), (*(argv[i]+1))) {
			case 'A': param.alt=1; break;
			case 'U': param.upper=1; break;
			default: argc=1; break;
		}
		else if (!*s_infile) strcpy(s_infile, argv[i]);
		else if (!*s_outfile) strcpy(s_outfile, argv[i]);
		else argc=1;
	}
	if (!*s_infile || argc==1) {
		puts("\nPouit: HTMLIMGS.EXE vstup.htm [vstup.htm]");
		puts("     /A: pidat atribut ALT se jmnem a velikost obrzku");
		puts("     /U: vkldat znaky velkmi psmeny");
		puts("\nProgram do dokumentu HTML ke znakm <IMG> dopln velikosti obrzk GIF a JPG.");
		return 1;
	}
	if (!(infile = fopen(s_infile, "r"))) { fprintf(stderr, "\nNelze otevt vstupn HTML soubor\n"); return 2; }
	if (!(outfile = fopen(argc >= 3 ? s_outfile : "htmlimgs.out", "w"))) { fprintf(stderr, "\nNelze otevt vstupn soubor\n"); return 2; }
	if (s=strrchr(s_infile, '\\')) { strcpy(path, s_infile); path[s-s_infile+1]=0; }
	else *path=0;
	for (lambda=0, stav=0; lambda || (i=getc(infile)) != EOF; ) {
		lambda=0;
		if (stavy[stav][1] >= 0) out[outcount++] = i;
		for (jinak=1, j=2; stavy[stav][j] != -1; j=j+2)
			if (stavy[stav][j] == i || outcount == MAXSTR-1 || (i == ' ' && (stavy[stav][j] == '\n' || stavy[stav][j] == '\r'))) {
				if (stavy[stav][1] >= 0 || outcount == MAXSTR-1) {
					out[outcount - (outcount == MAXSTR-1 ? 0 : 1)]=0;
					outstav = outf(outstav, &imginfo, stavy[stav][1], out);
					outcount=0;
				}
				stav=stavy[stav][j+1];
				jinak=0;
				break;
			}
		if (i == '>' && outstav == 1) {
			switch (imgsize(outfile, path, &imginfo)) {
				case 1: imgoks++; break;
				case 0: imgskips++; break;
				case -1: imgerrs++; break;
			}
			imginfo_reset(&imginfo);
		}
		if (jinak && stav != stavy[stav][0]) {
			lambda=1;
			stav=stavy[stav][0];
		}
		else putc(i, outfile);
	}
	fclose(infile);
	fclose(outfile);
	if (!*s_outfile) {
		unlink(s_infile);
		rename("htmlimgs.out", s_infile);
	}

	fprintf(stderr, "\nObrzky, kter se podailo zpracovat: %d\nObrzky, kter se nepodailo zpracovat: %d\nObrzky, kter nebylo poteba zpracovat: %d\n" , imgoks, imgerrs, imgskips);
	return 0;
}
